# Gate

## Build
First build client:
```jshelllanguage
sbt
sbt> go
```

Then launch the lab application server:
```jshelllanguage
sbt> project lab
sbt> run -s /path/to/your/settings/file // absolute or relative to lab/
```

where your settings file is something like:
```scala
Settings (
    port = 8990,
    MongoDB("opennole", "rocks", "localhost", 27017, "openmole", "login")
)
    //MongoDB(login, pass, host, port, db, dataset)
```

This will use the default MongoDB configuration (mongodb://openmole:rocks@localhost:27017/openmole?login). 
You can launch the jetty server with your own URI:
```jshelllanguage
project server // in sbt mode
run mongodb://myuser:mypassword@myhost:myport/mydb?mycollection
```


You need to have a MongoDB running with the corresponding user declared in the *admin* database (by convention).
To run a mongoDB using docker (you need to forward the port):
```jshelllanguage
cd docker
docker build -t openmole/mongo-gate .
mkdir -p data/{configdb,db}
docker run                                 \
    -v $(pwd)/data/db:/data/db             \
    -v $(pwd)/data/configdb:/data/configdb \
    --name openmole-gate-dummy             \
    -p 27017:27017                         \
    --restart=always                       \
    -e MONGO_INITDB_DATABASE=openmole      \
    -d openmole/mongo-gate:latest
```

This will start a MongoDB instance prepopulated with an `openmole` user and a dummy record in a `test` collection (as can be seen [this command file](docker/bootstrap.js)).

Then, browse [localhost:8080](localhost:8080)