package lab

import server.{Launcher, Settings}
import better.files._

object Gate extends App {

  def example =
    """
    Settings (
    port = 8989,
    MongoDB(xx,yyy, "localhost", 27017, "openmole", "login")
  )"""

case class Config(fileSetttings: Option[File] = None)

  val parser = new scopt.OptionParser[Config]("gate") {
    head("gate", "0.1")

    opt[String]('s', "settings").action { (x, c) =>
      c.copy(fileSetttings = Some(File(x)))
    }.text("the path to the settings files")
  }

  val config = parser.parse(args, Config()).get

  val settings = Settings.compile(
    config.fileSetttings match {
      case Some(s) => s.lines.mkString("\n")
      case _ => example
    }
  )

  Launcher.run(settings)
}