package server

import javax.servlet.ServletContext

import org.eclipse.jetty.server.Server
import org.eclipse.jetty.webapp.WebAppContext
import org.openmole.gate.server.Servlet
import org.scalatra.LifeCycle
import org.scalatra.servlet.ScalatraListener

object Launcher {
  val settingsKey = "settings"

  def run(settings: Settings) = {

    val server = new Server(settings.port)
    val context = new WebAppContext()

    context.setAttribute(settingsKey, settings)

    val webapp = getClass.getClassLoader.getResource("webapp").toExternalForm

    context setContextPath "/"
    context.setResourceBase(webapp)
    context.setInitParameter(ScalatraListener.LifeCycleKey, classOf[GateBootstrap].getCanonicalName)
    context.addEventListener(new ScalatraListener)
    server.setHandler(context)

    server.start
    server.join
  }
}

class GateBootstrap extends LifeCycle {
  override def init(context: ServletContext) {
    val settings = context.get(Launcher.settingsKey).get.asInstanceOf[Settings]
    context.mount(new Servlet(settings), "/*")
  }
}