package server

import javax.script.ScriptEngineManager

import org.openmole.gate.server.Data._

import scala.tools.nsc.interpreter.IMain

object Settings {

  def compile(content: String): Settings = {
    def imports =
      """
        |import server._
        |import Settings.MongoDB
        |
      """.stripMargin

    val e = new ScriptEngineManager(this.getClass.getClassLoader).getEngineByName("scala")
    val settings = e.eval(imports ++ content).asInstanceOf[Settings]

    settings
  }

  case class MongoDB(user: Login, password: Password, host: String, port: Int, db: String, dataSet: String)

}


case class Settings(port: Int, mongoDB: Settings.MongoDB)